GRAMMAR_SOURCES = \
ProgGenGrammar \
ProgGenGrammar.awk \
ProgGenTokens \
ProgGenTokens.awk 

C_SOURCES = \
ProgGraphObject.crt \
ProgAttr.crt \
ProgAttribute.crt \
ProgVertex.crt \
ProgEdge.crt \
ProgGraph.crt 

SOURCES = \
ProgAdjacencyMatrix.tbl \
ProgAttribute.tbl \
ProgAttr.tbl \
ProgGraph.tbl \
ProgGraphBuild.tbl \
ProgGraphObject.tbl \
ProgGraphOperations.tbl \
ProgVertex.tbl \
ProgEdge.tbl

load:	$(SOURCES) $(C_SOURCES) $(GRAMMAR_SOURCES)
	- chmod +x *Gen*

clean:  
	- rm -f *.tex

.SUFFIXES:
.SUFFIXES: .tbl .crt .tbl.tex .crt.tex

.tbl.tbl.tex:
	$(DOC)/link_filter $<

.crt.crt.tex:
	$(DOC)/link_c_filter $<

C_OBJECTS = \
	$(C_SOURCES:.crt=.crt.tex)

OBJECTS = \
	$(SOURCES:.tbl=.tbl.tex)


PARSER_DEPS =  $(LINK_BASE)/src/graph/parser.y  \
	ProgGenGrammar \
	ProgGenGrammar.awk 

SCANNER_DEPS =  $(LINK_BASE)/src/graph/scanner.l  \
	ProgGenTokens \
	ProgGenTokens.awk 

SPECIAL_TEXS = tokens.tex parser.tex

parser.tex:	$(PARSER_DEPS)
	ProgGenGrammar

tokens.tex:	$(SCANNER_DEPS)
	ProgGenTokens

document:  $(SOURCES.tbl) $(OBJECTS) $(C_SOURCES.crt) \
		$(C_OBJECTS) $(SPECIAL_TEXS)
	chmod -f 666 *.tex

$(OBJECTS): $(DOC)/link_filter 

$(C_OBJECTS): $(DOC)/link_c_filter

